/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 一括登録実行クラス
//
//	変更履歴
//		2004.01.08 新規作成 T.Nishiki 
//
package jp.co.ntt.lms.xms.lumpfile;

import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.xmo.LumpInsert.LumpInsertClient;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsWarningException;
import jp.co.ntt.lms.xms.common.mail.SendUser;
import jp.co.ntt.lms.xms.common.util.CommonUtil;
import jp.co.ntt.lms.xms.common.util.StringUtil;

/**
 * 一括登録実行クラス。<br>
 * @author T.Nishiki
 */
public class LumpFileRegistAction extends XmsBusinessAction {

	/**
	 * リクエスト処理初期化メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void initProcessRequest(XmsRequest xmsRequest)
		throws XmsException {
	}

	/**
	 * リクエスト処理メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {

		String submitMail = null;
		// 一括登録クライアント
		LumpInsertClient client = null;
		boolean insertResult = false;

		// 入力項目データクラス
		LumpFileInputBean inputBean = null;
		// エラーメッセージ。この変数に値が入っている場合は、
		// XmsWarningExceptionのエラーメッセージより優先される。
		String errorMessage = null;
		// 一括登録したユーザIDリスト（メール送信用）
		Vector registedUserIDs = null;
		try {
			////////////////////////////////////////////////////////////////////
			// 入力項目の取得
			inputBean = getInputBean(xmsRequest);
			////////////////////////////////////////////////////////////////////
			// 一括登録処理
			// =================================================================
			// 登録内容設定
			// 一括登録クライアント生成
			client = new LumpInsertClient();
			// 一括登録ファイル名設定
			client.setLumpFileName(inputBean.getLumpFileName());
			// 一括登録Mail送信フラグ設定
			if (inputBean.isSubmitMail() == true) {
				submitMail = Integer.toString(LumpFileConstant.SUBMIT_MAIL);
			} else {
				submitMail = Integer.toString(LumpFileConstant.SUBMIT_NO_MAIL);
			}
			client.setSendMail(submitMail);
			// 登録先グループID
			client.setLumpRootGroup(inputBean.getParentID());
			// =================================================================
			// 一括登録実行
			insertResult = client.insert();
			if (insertResult == false) {
				errorMessage = client.getMessage();
				throw new XmsWarningException(
					LumpFileConstant.KEY_MESSAGE_FAIL_REGIST);
			}
			// 登録対象を取得
			registedUserIDs = client.getInsertUserList();
			////////////////////////////////////////////////////////////////////
			// セッションから不要となった入力情報を削除
			CommonUtil.removeSessionData(
				xmsRequest,
				LumpFileConstant.KEY_INPUT_BEAN);
			////////////////////////////////////////////////////////////////////
			// メール送信処理
			// =================================================================
			if (inputBean.isSubmitMail() == false) {
				// メール送信しない場合、メール送信なしの終了処理へ。
				xmsResponse.setBusinessStatus(LumpFileConstant.STATUS_NO_MAIL);
			} else if (
				registedUserIDs == null || registedUserIDs.size() == 0) {
				// 送信対象者が存在しない場合、メール送信なしの終了処理へ。
				xmsResponse.setBusinessStatus(LumpFileConstant.STATUS_NO_MAIL);
			} else {
				// 送信対象者が存在する場合、情報をセッションに登録。
				setUserInformationToSession(xmsRequest, registedUserIDs);
			}
		} catch (XmsException e) {
			// エラーメッセージがない場合、Exceptionからメッセージを取得する。
			if (StringUtil.isNullString(errorMessage) == true) {
				errorMessage = e.getMessage();
			}
			LumpFileUtil.setErrorInformation(xmsResponse, errorMessage);
		} catch (Exception e) {
			DebugLog.write(this.getClass(), e, DebugLog.HIGHT);
			throw new XmsInnerException(e);
		}
	}

	/**
	 * 送信されてきた情報から、LumpFileInputBeanを生成する。<br>
	 * @param xmsRequest リクエスト・オブジェクト。
	 * @return 生成したCustomAssignInputBeanオブジェクト。
	 */
	private LumpFileInputBean getInputBean(XmsRequest xmsRequest)
		throws XmsException {
		// このメソッドの戻り値。
		LumpFileInputBean inputBean = null;

		try {
			inputBean = new LumpFileInputBean();
			// =================================================================
			// 登録先親グループID
			String parentID = null;
			parentID = xmsRequest.getParameter(LumpFileConstant.NAME_PARENT_ID);
			inputBean.setParentID(parentID);
			// =================================================================
			// 一括登録ファイル名
			String strUploadFileName = null;
			strUploadFileName =
				xmsRequest.getParameter(LumpFileConstant.NAME_REGIST_FILE);
			inputBean.setLumpFileName(strUploadFileName);
			// =================================================================
			// メール送信
			String submitMail = null;
			int intSubmitMail = 0;
			submitMail =
				xmsRequest.getParameter(LumpFileConstant.NAME_SUBMIT_MAIL);
			intSubmitMail =
				StringUtil.parseInt(
					submitMail,
					LumpFileConstant.SUBMIT_NO_MAIL);
			inputBean.setSubmitMail(
				intSubmitMail == LumpFileConstant.SUBMIT_MAIL);
			// =================================================================
			// アップロード完了メッセージを消去する。
			inputBean.clearUploadCompleteMessage();
			
		} catch (Exception e) {
			DebugLog.write(
				this.getClass(),
				"Exception occured at getInputBean:" + e,
				DebugLog.HIGHT);
			throw new XmsInnerException(e);
		}
		return inputBean;
	}

	/**
	 * 送信ユーザ情報をセッションに登録する。<br>
	 * @param xmsRequest リクエストオブジェクト。
	 * @param assignUserIDs 設定するユーザのIDリスト。
	 */
	private void setUserInformationToSession(
		XmsRequest xmsRequest,
		Vector assignUserIDs)
		throws XmsException {

		// 送信ユーザ情報
		SendUser sendUser = null;
		// HTTPリクエスト
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;
		// 送信件数取得用
		LumpInsertClient client = null;
		// 送信件数
		int sendMailCount = 0;
		try {
			// 送信件数の取得
			client = new LumpInsertClient();
			sendMailCount = client.getSendMailCount();
			////////////////////////////////////////////////////////////////////
			// 送信ユーザ情報の生成、値設定
			//==================================================================
			sendUser = new SendUser();
			// メール種別（一括登録）
			sendUser.setMailType(LumpFileConstant.MAIL_TYPE_LUMPFILE_INT);
			// 一回あたりの送信件数
			sendUser.setSendCountMax(sendMailCount);
			// 送信対象ユーザID
			sendUser.setUserAndLo(assignUserIDs);
			// 送信結果画面「閉じるボタン」のアクションID
			sendUser.setCloseActionID(LumpFileConstant.ACTION_ID_CLOSE);
			// 送信ユーザ情報の格納
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			if (session != null) {
				session.setAttribute(LumpFileConstant.KEY_SEND_USER, sendUser);
			}
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}
}
